REM https://sourceforge.net/projects/pyqt/files/QScintilla2/QScintilla-2.10.1/QScintilla_gpl-2.10.1.tar.gz

set P=qscintilla-qt5
set V=2.10.1
set B=1

if "%OSGEO4W_REP%"=="" (
        echo no repository
        exit 1
)

set ARCH=%1

if "%ARCH%"=="x86" (
        set OSGEO4W_ROOT=C:\OSGeo4W
        set VCARCH=x86
) else if "%ARCH%"=="x86_64" (
        set OSGEO4W_ROOT=C:\OSGeo4W64
        set VCARCH=amd64
) else (
        echo invalid arch
        exit
)

set R=%OSGEO4W_REP%\%ARCH%\release
if not exist %R%\qt5\qscintilla-qt5 mkdir %R%\qt5\qscintilla-qt5
if not exist %R%\python3\python3-qscintilla mkdir %R%\python3\python3-qscintilla

call "%OSGEO4W_ROOT%\bin\o4w_env.bat"
call "%OSGEO4W_ROOT%\bin\py3_env.bat"
call "%OSGEO4W_ROOT%\bin\qt5_env.bat"
call "c:\Program Files (x86)\Microsoft Visual Studio 14.0\VC\vcvarsall.bat" %VCARCH%
path %PATH%;c:\cygwin\bin
echo on

set INCLUDE=%INCLUDE%;%OSGEO4W_ROOT%\include
set LIB=%LIB%;%OSGEO4W_ROOT%\lib

copy setup.hint %R%\qt5\qscintilla-qt5\setup.hint
copy python.hint %R%\python3\python3-qscintilla\setup.hint

cd ..\Qt4Qt5
perl -i -pe "s/^TARGET =.*$/TARGET = qscintilla2-qt5/" qscintilla.pro
qmake qscintilla.pro
if errorlevel 1 (echo qmake error & goto error)

jom clean
if errorlevel 1 (echo clean error & goto error)

jom
if errorlevel 1 (echo make error & goto error)

jom install
if errorlevel 1 (echo install error & goto error)

move %OSGEO4W_ROOT%\apps\Qt5\lib\qscintilla2-qt5.lib %OSGEO4W_ROOT%\apps\Qt5\lib\qscintilla2.lib

cd ..\Python
python configure.py --verbose --pyqt=PyQt5
if errorlevel 1 (echo python configure error & goto error)

jom clean
if errorlevel 1 (echo python clean error & goto error)

jom
if errorlevel 1 (echo python build error & goto error)

jom install
if errorlevel 1 (echo python install error & goto error)
cd ..

move %OSGEO4W_ROOT%\apps\Qt5\lib\qscintilla2_qt5.dll %OSGEO4W_ROOT%\apps\Qt5\bin
copy %OSGEO4W_ROOT%\apps\Qt5\lib\qscintilla2_qt5.lib %OSGEO4W_ROOT%\apps\Qt5\lib\qscintilla2.lib

copy ..\OPENSOURCE-NOTICE.TXT+..\LICENSE.GPL2+..\LICENSE.GPL3 %R%\qt5\qscintilla-qt5\qscintilla-qt5-%V%-%B%.txt
tar --remove-files -C %OSGEO4W_ROOT% -cjvf %R:c:=/c%\qt5\qscintilla-qt5\qscintilla-qt5-%V%-%B%.tar.bz2 ^
	apps/Qt5/qsci/api/python ^
	apps/Qt5/include/Qsci ^
	apps/Qt5/translations/qscintilla_cs.qm ^
	apps/Qt5/translations/qscintilla_de.qm ^
	apps/Qt5/translations/qscintilla_es.qm ^
	apps/Qt5/translations/qscintilla_fr.qm ^
	apps/Qt5/translations/qscintilla_pt_br.qm ^
	apps/Qt5/lib/qscintilla2.lib ^
	apps/Qt5/lib/qscintilla2_qt5.lib ^
	apps/Qt5/bin/qscintilla2_qt5.dll
if errorlevel 1 (echo lib error & goto error)

copy ..\OPENSOURCE-NOTICE.TXT+..\LICENSE.GPL2+..\LICENSE.GPL3 %R%\python3\python3-qscintilla\python3-qscintilla-%V%-%B%.txt
tar --remove-files -C %OSGEO4W_ROOT% -cjvf %R:c:=/c%\python3\python3-qscintilla\python3-qscintilla-%V%-%B%.tar.bz2 ^
        apps/Python36/Lib/site-packages/PyQt5/Qsci.pyd ^
	apps/Python36/sip/PyQt5/Qsci
if errorlevel 1 (echo python error & goto error)

tar -cjvf %R:c:=/c%\qt5\qscintilla-qt5\qscintilla-qt5-%V%-%B%-src.tar.bz2 ^
	osgeo4w/package.cmd ^
	osgeo4w/python.hint ^
	osgeo4w/setup.hint
if errorlevel 1 (echo src error & goto error)

exit 0

:error
exit /b 1
